Ruby - Bug #12164

Binding UnboundMethod to BasicObject
03/10/2016 11:22 AM - decuplet (Nikita Shilnikov)

Status: Closed
Priority: Normal
Assignee:

Target version:

ruby -v: ruby 2.3.0p0 (2015-12-25 revision Backport: 2.1: UNKNOWN, 2.2: UNKNOWN, 2.3:
53290) [x86_64-darwin15] UNKNOWN

Description

| tried to bind method from Object to BasicObject and | suddenly succeeded.

For example:

$ irb

2.3.0 :001 > BasicObiject.send :define_method, :methods, Object.instance_method (:methods)
=> :methods
2.3.0 :002 > BasicObiject.new.methods

[:!, :==, :!=, :__send__, :equal?, :methods, :instance_eval, :instance_exec, :__id__]

In earlier ruby versions such code would raise an exception:

S irb

2.2.4 :001 > BasicObject.send :define_method, :methods, Object.instance_method (:methods)
TypeError: bind argument must be a subclass of Object

from (irb):1:in “define_method’

from (irb):1

from /Users/gordon/.rvm/rubies/ruby-2.2.4/bin/irb:11:in "~ <main>'

2.2.4 :002 >

Is it a bug or a feature?
Probably it is somehow related to https://bugs.ruby-lang.org/issues/11278

Related issues:
Related to Ruby - Bug #11278: remove rb_control_frame_t::klass Closed

History

#1 - 03/10/2016 01:16 PM - nobu (Nobuyoshi Nakada)
- Description updated

- Status changed from Open to Closed

Yes.

#2 - 03/10/2016 02:04 PM - decuplet (Nikita Shilnikov)

Nobuyoshi Nakada wrote:

Yes.

Thank you! Well... a feature?

#3 - 03/11/2016 12:42 AM - nobu (Nobuyoshi Nakada)

"Yes" was to

Probably it is somehow related to https://bugs.ruby-lang.org/issues/11278

| guess it's a bug-fix, but maybe an improvement.
Subtle.
https://bugs.ruby-lang.org/issues/11278
https://bugs.ruby-lang.org/issues/11278

#4 - 03/24/2016 07:30 AM - usa (Usaku NAKAMURA)
- Related to Bug #11278: remove rb_control_frame_t: klass added
